﻿using BPA.SAAS.KitChenManage.Application.AExternalPlatform.BaseDto;
using BPA.SAAS.KitChenManage.Application.AExternalPlatform1.Service.Goods.Dtos;
using BPA.SAAS.KitChenManage.Comm.Tool;
using BPA.SAAS.KitChenManage.Core.Model;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BPA.SAAS.KitChenManage.Application.AExternalPlatform1.Service.Goods.Services
{

    [ApiDescriptionSettings("开放平台", Tag = "商品信息"), AllowAnonymous, NonUnify]
    public class Goods: IGoodsServices, ITransient,IDynamicApiController
    {

        private readonly ISqlSugarClient _db;
        public Goods(ISqlSugarClient db)
        {
            _db = db;
        }
        /// <summary>
        /// 获取设备物料信息
        /// </summary>
        /// <returns></returns>
        [HttpPost("/api/goods/Getdevicegoods")]
        public async Task<ResultGoodsResultDto> GetDeviceGoods(string deviceId)
        {


            var goodsId = await _db.Queryable<BPA_DeviceGoods>()
                .Where(x => x.DeviceId == deviceId)
                .Select(x => x.GoodsId)
                .ToListAsync();

            var data = await GetDeviceGoodspost(goodsId);

            return data;
        }


        /// <summary>
        /// 获取商品信息
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public async Task<ResultGoodsResultDto> GetDeviceGoodspost(List<string> goodsList)
        {
            try
            {


                Dictionary<string, string> dic = new Dictionary<string, string>();
                var url = App.Configuration["baseurl"] + "api/goods/GetGoodsListByIds";
                var inputData = JsonConvert.SerializeObject(goodsList);
                var jsonData = HttpHelper.PostData(url, inputData, Encoding.UTF8, "application/json", dic);
                var data = JsonConvert.DeserializeObject<ResultGoodsResultDto>(jsonData);
                return data;
            }
            catch (Exception ex)
            {

                throw Oops.Oh("获取商品失败");
            }


        }
    }
}
